/* This is  -*- C++ -*-  */
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///  \file  gapCASModule.h
///  \brief Defines an interface to GAP.
///  \author Thomas Feulner <thomas.feulner@uni-bayreuth.de>
///  \date   2010-09-29
///
///  Copyright (C) 2010 Thomas Feulner <thomas.feulner@uni-bayreuth.de>
///  Distributed  under  the  terms  of  the  GNU  General  Public  License (GPL)
///  http://www.gnu.org/licenses/
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


#ifndef GAPCASMODULE_H_
#define GAPCASMODULE_H_

#include "abstractCASModule.h"

class GapCASModule : private AbstractCASModule
{
public:
	GapCASModule(char* call[], const std::string& packagesFolder);
	~GapCASModule();

	void initTrivialSn(const std::string& group, int n);
	void getFather(const std::string& group, std::vector<int>& father, My_Long_Int& group_order );
	void extendGroup(const std::string& group, const Permutation& newgen, int n) ;
	void buildGroup(const std::string& group, const std::vector<Permutation>& newgens, int n) ;
	My_Long_Int getOrder( const std::string& group );
private:
};

#endif /*GAPCASMODULE_H_*/
